import { ResourceObject, ResourceObjectRelationships } from '@klerick/json-api-nestjs-shared';
import { InterceptorsContextCreator } from '@nestjs/core/interceptors';
import { ParamsForExecute } from '../types';
import { ValidateQueryError } from '../../../types';
export declare function isZodError(param: string | unknown): param is {
    message: ValidateQueryError[];
};
export declare class ExecuteService {
    private readonly moduleRef;
    private asyncIteratorFactory;
    private runInTransaction;
    private mapControllerInterceptor;
    private asyncLocalStorage;
    private _interceptorsContextCreator;
    get interceptorsContextCreator(): InterceptorsContextCreator;
    private interceptorsConsumer;
    run(params: ParamsForExecute[], tmpIds: (string | number)[]): Promise<(ResourceObject<object> | ResourceObjectRelationships<object, string, never>)[]>;
    protected executeOperations(params: ParamsForExecute[], tmpIds?: (string | number)[]): Promise<(ResourceObject<object> | ResourceObjectRelationships<object, string, never>)[]>;
    private getInterceptorsArray;
    replaceTmpIds<T extends ParamsForExecute['params']>(inputParams: T, tmpIdsMap: Record<string | number, string | number>): T;
    private getControllerInstance;
    private processException;
    private runOneOperation;
    private runPipes;
    private getPipeInstance;
}
