import { Type } from '@nestjs/common';
import { Module } from '@nestjs/core/injector/module';
import { Operation } from '@klerick/json-api-nestjs-shared';
import { OperationMethode } from '../types';
import { InputArray } from '../utils';
import { JsonBaseController } from '../../mixin/controllers/json-base.controller';
export declare class ExplorerService<E extends object = object> {
    private readonly modulesContainer;
    private readonly mapEntity;
    private readonly mapController;
    private mapModuleByController;
    getControllerByEntityName(entityName: string): Type<JsonBaseController<E>>;
    getMethodNameByParam(operation: Operation, id?: string, rel?: string): OperationMethode<E>;
    getParamsForMethod(methodName: OperationMethode<E>, data: InputArray[number]): Parameters<JsonBaseController<E>[typeof methodName]>;
    getModulesByController(controllers: Type<JsonBaseController<E>>): Module;
}
