"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nameIt = void 0;
exports.getProviderName = getProviderName;
exports.excludeMethod = excludeMethod;
exports.entityForClass = entityForClass;
const json_api_nestjs_shared_1 = require("@klerick/json-api-nestjs-shared");
const change_case_commonjs_1 = require("change-case-commonjs");
const bindings_1 = require("../config/bindings");
const constants_1 = require("../../../constants");
const nameIt = (name, cls) => ({
    [name]: class extends cls {
        constructor(...arg) {
            super(...arg);
        }
    },
}[name]);
exports.nameIt = nameIt;
function getProviderName(entity, name) {
    const entityName = (0, json_api_nestjs_shared_1.getEntityName)(entity);
    return `${(0, change_case_commonjs_1.pascalCase)(entityName)}${name}`;
}
function excludeMethod(names) {
    const tmpObject = names.reduce((acum, key) => ((acum[key] = true), acum), {});
    return json_api_nestjs_shared_1.ObjectTyped.keys(bindings_1.Bindings).filter((method) => !tmpObject[method]);
}
function entityForClass(type) {
    return Reflect.getMetadata(constants_1.JSON_API_DECORATOR_ENTITY, type);
}
//# sourceMappingURL=utils.js.map