"use strict";
var ErrorInterceptors_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorInterceptors = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const service_1 = require("../service");
const rxjs_1 = require("rxjs");
let ErrorInterceptors = class ErrorInterceptors {
    static { ErrorInterceptors_1 = this; }
    errorFormatService;
    static _instance;
    constructor() {
        if (ErrorInterceptors_1._instance) {
            return ErrorInterceptors_1._instance;
        }
        ErrorInterceptors_1._instance = this;
    }
    intercept(context, next) {
        return next
            .handle()
            .pipe((0, rxjs_1.catchError)((error) => (0, rxjs_1.throwError)(() => this.errorFormatService.formatError(error))));
    }
};
exports.ErrorInterceptors = ErrorInterceptors;
tslib_1.__decorate([
    (0, common_1.Inject)(service_1.ErrorFormatService),
    tslib_1.__metadata("design:type", service_1.ErrorFormatService)
], ErrorInterceptors.prototype, "errorFormatService", void 0);
exports.ErrorInterceptors = ErrorInterceptors = ErrorInterceptors_1 = tslib_1.__decorate([
    (0, common_1.Injectable)(),
    tslib_1.__metadata("design:paramtypes", [])
], ErrorInterceptors);
//# sourceMappingURL=error.interceptors.js.map