"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.factoryMixin = factoryMixin;
exports.queryInputMixin = queryInputMixin;
exports.queryMixin = queryMixin;
exports.queryFiledInIncludeMixin = queryFiledInIncludeMixin;
exports.queryCheckSelectFieldMixin = queryCheckSelectFieldMixin;
exports.idPipeMixin = idPipeMixin;
exports.checkItemEntityPipeMixin = checkItemEntityPipeMixin;
exports.postInputPipeMixin = postInputPipeMixin;
exports.patchInputPipeMixin = patchInputPipeMixin;
exports.postRelationshipPipeMixin = postRelationshipPipeMixin;
exports.patchRelationshipPipeMixin = patchRelationshipPipeMixin;
exports.parseRelationshipNamePipeMixin = parseRelationshipNamePipeMixin;
const common_1 = require("@nestjs/common");
const change_case_commonjs_1 = require("change-case-commonjs");
const query_input_1 = require("./query-input");
const query_1 = require("./query");
const query_filed_on_include_1 = require("./query-filed-on-include");
const query_check_select_field_1 = require("./query-check-select-field");
const check_item_entity_1 = require("./check-item-entity");
const post_input_1 = require("./post-input");
const patch_input_1 = require("./patch-input");
const parse_relationship_name_1 = require("./parse-relationship-name");
const post_relationship_1 = require("./post-relationship");
const patch_relationship_1 = require("./patch-relationship");
const helpers_1 = require("../helpers");
function factoryMixin(entity, pipe) {
    const entityName = entity.name;
    const pipeClass = (0, helpers_1.nameIt)(`${(0, change_case_commonjs_1.pascalCase)(entityName)}${pipe.name}`, pipe);
    (0, common_1.Injectable)()(pipeClass);
    return pipeClass;
}
function queryInputMixin(entity) {
    return factoryMixin(entity, query_input_1.QueryInputPipe);
}
function queryMixin(entity) {
    return factoryMixin(entity, query_1.QueryPipe);
}
function queryFiledInIncludeMixin(entity) {
    return factoryMixin(entity, query_filed_on_include_1.QueryFiledInIncludePipe);
}
function queryCheckSelectFieldMixin(entity) {
    return factoryMixin(entity, query_check_select_field_1.QueryCheckSelectField);
}
function idPipeMixin(entity, config) {
    return config && config.pipeForId ? config.pipeForId : common_1.ParseIntPipe;
}
function checkItemEntityPipeMixin(entity) {
    return factoryMixin(entity, check_item_entity_1.CheckItemEntityPipe);
}
function postInputPipeMixin(entity) {
    return factoryMixin(entity, post_input_1.PostInputPipe);
}
function patchInputPipeMixin(entity) {
    return factoryMixin(entity, patch_input_1.PatchInputPipe);
}
function postRelationshipPipeMixin(entity) {
    return factoryMixin(entity, post_relationship_1.PostRelationshipPipe);
}
function patchRelationshipPipeMixin(entity) {
    return factoryMixin(entity, patch_relationship_1.PatchRelationshipPipe);
}
function parseRelationshipNamePipeMixin(entity) {
    return factoryMixin(entity, parse_relationship_name_1.ParseRelationshipNamePipe);
}
//# sourceMappingURL=index.js.map