"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntityParamMapService = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const constants_1 = require("../../../constants");
let EntityParamMapService = class EntityParamMapService {
    entityParamMap;
    currentEntity;
    _entityParaMap;
    getParamMap(entity) {
        const paramMap = this.entityParamMap.get(entity);
        if (!paramMap)
            throw new Error(`Param map for: ${entity.name} not found`);
        return paramMap;
    }
    get entityParaMap() {
        if (!this._entityParaMap) {
            this._entityParaMap = this.getParamMap(this.currentEntity);
        }
        return this._entityParaMap;
    }
};
exports.EntityParamMapService = EntityParamMapService;
tslib_1.__decorate([
    (0, common_1.Inject)(constants_1.ENTITY_PARAM_MAP),
    tslib_1.__metadata("design:type", Object)
], EntityParamMapService.prototype, "entityParamMap", void 0);
tslib_1.__decorate([
    (0, common_1.Inject)(constants_1.CURRENT_ENTITY),
    tslib_1.__metadata("design:type", Object)
], EntityParamMapService.prototype, "currentEntity", void 0);
exports.EntityParamMapService = EntityParamMapService = tslib_1.__decorate([
    (0, common_1.Injectable)()
], EntityParamMapService);
//# sourceMappingURL=entity-param-map.service.js.map