"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodPatch = zodPatch;
const zod_1 = require("zod");
const zod_share_1 = require("../zod-share");
function getShape(entityParamMapService) {
    const shape = {
        id: (0, zod_share_1.zodId)(entityParamMapService.entityParaMap.primaryColumnType),
        type: (0, zod_share_1.zodType)(entityParamMapService.entityParaMap.typeName),
        attributes: (0, zod_share_1.zodAttributes)(entityParamMapService, true).optional(),
        relationships: (0, zod_share_1.zodRelationships)(entityParamMapService, true).optional(),
    };
    return zod_1.z.object(shape).strict();
}
function zodPatch(entityParamMapService) {
    const shape = getShape(entityParamMapService);
    return zod_1.z
        .object({
        data: shape,
    })
        .strict();
}
//# sourceMappingURL=index.js.map