import { z, ZodObject, ZodOptional } from 'zod';
import { ZodId, ZodType, ZodAttributes, ZodRelationships } from '../zod-share';
import { EntityParamMapService } from '../../service';
type ZodInputPostShape<E extends object, IdKey extends string> = {
    id: ZodOptional<ZodId>;
    type: ZodType<string>;
    attributes: ZodAttributes<E, IdKey>;
    relationships: ZodOptional<ZodRelationships<E, IdKey>>;
};
type ZodInputPostSchema<E extends object, IdKey extends string> = ZodObject<ZodInputPostShape<E, IdKey>, 'strict'>;
type ZodInputPostDataShape<E extends object, IdKey extends string> = {
    data: ZodInputPostSchema<E, IdKey>;
};
export declare function zodPost<E extends object, IdKey extends string>(entityParamMapService: EntityParamMapService<E, IdKey>): ZodPost<E, IdKey>;
export type ZodPost<E extends object, IdKey extends string> = ZodObject<ZodInputPostDataShape<E, IdKey>, 'strict'>;
export type Post<E extends object, IdKey extends string> = z.infer<ZodPost<E, IdKey>>;
export type PostData<E extends object, IdKey extends string> = Post<E, IdKey>['data'];
export {};
