import { z } from 'zod';
import { EntityParam, EntityRelationProps, NonEmptyStringTuple } from '../../../../types';
import { EntityParamMapService } from '../../service';
declare function getZodFieldRule<E extends object, IdKey extends string, PropsList extends ShapeArrayInput<E, IdKey>>(fields: PropsList): z.ZodOptional<z.ZodEffects<z.ZodArray<z.ZodEnum<z.Writeable<NonEmptyStringTuple<PropsList>>>, "atleastone">, [z.Writeable<NonEmptyStringTuple<PropsList>>[number], ...z.Writeable<NonEmptyStringTuple<PropsList>>[number][]], [z.Writeable<NonEmptyStringTuple<PropsList>>[number], ...z.Writeable<NonEmptyStringTuple<PropsList>>[number][]]>>;
type ShapeArrayInput<E extends object, IdKey extends string> = EntityParam<E, IdKey>['props'] | EntityRelationProps<E, IdKey>[keyof EntityRelationProps<E, IdKey>];
type ZodFieldRule<E extends object, IdKey extends string, PropsList extends ShapeArrayInput<E, IdKey>> = ReturnType<typeof getZodFieldRule<E, IdKey, PropsList>>;
type ZodFieldsShape<E extends object, IdKey extends string> = {
    target: ZodFieldRule<E, IdKey, EntityParam<E, IdKey>['props']>;
} & {
    [K in keyof EntityRelationProps<E, IdKey>]: ZodFieldRule<E, IdKey, EntityRelationProps<E, IdKey>[K]>;
};
export declare function zodFieldsQuery<E extends object, IdKey extends string>(entityParamMapService: EntityParamMapService<E, IdKey>): z.ZodNullable<z.ZodEffects<z.ZodObject<ZodFieldsShape<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodFieldsShape<E, IdKey>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodFieldsShape<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ZodFieldsShape<E, IdKey>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<ZodFieldsShape<E, IdKey>>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodFieldsShape<E, IdKey>>, any> extends infer T_2 ? { [k in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodFieldsShape<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ZodFieldsShape<E, IdKey>> extends infer T_3 ? { [k_1 in keyof T_3]: z.baseObjectInputType<ZodFieldsShape<E, IdKey>>[k_1]; } : never>>;
export type ZodFieldsQuery<E extends object, IdKey extends string> = ReturnType<typeof zodFieldsQuery<E, IdKey>>;
export type FieldsQuery<E extends object, IdKey extends string> = z.infer<ZodFieldsQuery<E, IdKey>>;
export {};
