import { z, ZodObject } from 'zod';
import { QueryField } from '@klerick/json-api-nestjs-shared';
import { ZodFieldsQuery } from './fields';
import { ZodFilterQuery } from './filter';
import { ZodIncludeQuery } from './include';
import { ZodSortQuery, SortQuery } from './sort';
import { ZodPageInputQuery } from '../zod-share';
import { EntityParamMapService } from '../../service';
export { SortQuery };
type Shape<E extends object, IdKey extends string> = {
    [QueryField.fields]: ZodFieldsQuery<E, IdKey>;
    [QueryField.filter]: ZodFilterQuery<E, IdKey>;
    [QueryField.include]: ZodIncludeQuery<E, IdKey>;
    [QueryField.sort]: ZodSortQuery<E, IdKey>;
    [QueryField.page]: ZodPageInputQuery;
};
export declare function zodQuery<E extends object, IdKey extends string = 'id'>(entityParamMapService: EntityParamMapService<E, IdKey>): z.ZodObject<Shape<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<Shape<E, IdKey>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<Shape<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<Shape<E, IdKey>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<Shape<E, IdKey>>[k_1]; } : never>;
export type ZodQuery<E extends object, IdKey extends string> = ZodObject<Shape<E, IdKey>, 'strict'>;
export type Query<E extends object, IdKey extends string> = z.infer<ZodObject<Shape<E, IdKey>, 'strict'>>;
declare function zodQueryOne<E extends object, IdKey extends string = 'id'>(entityParamMapService: EntityParamMapService<E, IdKey>): ZodObject<Pick<Shape<E, IdKey>, QueryField.fields | QueryField.include>, 'strict'>;
export type ZodQueryOne<E extends object, IdKey extends string> = ReturnType<typeof zodQueryOne<E, IdKey>>;
export type QueryOne<E extends object, IdKey extends string> = z.infer<ZodQueryOne<E, IdKey>>;
