import { ZodType } from 'zod';
import { EntityRelationProps, TypeField } from '../../../types';
import { EntityParamMapService } from '../service';
import { ResultSchema } from './zod-share';
export declare const nonEmptyObject: () => <T>(object: T) => boolean;
export declare const uniqueArray: () => (e: string[]) => boolean;
export declare const getValidationErrorForStrict: (props: string[], name: "Fields" | "Filter") => string;
export declare const oneOf: (keys: string[]) => (val: any) => boolean;
export declare const stringLongerThan: (length?: number) => (str: string) => boolean;
export declare const arrayItemStringLongerThan: (length?: number) => (array: [string | null, ...(string | null)[]]) => boolean;
export declare const stringMustBe: (type?: TypeField) => (inputString: string | null) => boolean;
export declare const elementOfArrayMustBe: (type?: TypeField) => (inputArray: unknown[]) => boolean;
export declare function guardIsKeyOfObject<R>(object: R, key: string | number | symbol): asserts key is keyof R;
export declare function getRelationProps<E extends object, IdKey extends string>(entityParamMapService: EntityParamMapService<E, IdKey>): EntityRelationProps<E, IdKey>;
export declare function setOptionalOrNot<Schema extends ZodType, Null extends true | false, isPatch extends true | false>(schema: Schema, isNullable: Null, isPatch: isPatch): ResultSchema<Schema, Null, isPatch>;
